directory-ospath-streaming-0.2.2: Stream directory entries in constant memory in vanilla IO

Copyright | (c) Sergey Vinokurov 2024
License | Apache-2.0 (see LICENSE)
Maintainer | serg.foo@gmail.com
Safe Haskell | None
Language | Haskell2010

System.Directory.OsPath.Types

Description

Synopsis

- data SymlinkType
  - = Regular
  - | Symlink
- data FileType
  - = File !SymlinkType
  - | Directory !SymlinkType
  - | Other !SymlinkType
- newtype Basename a = Basename {
  - unBasename :: a
  }
- newtype Relative a = Relative {
  - unRelative :: a
  }

# Documentation

data SymlinkType Source #

Constructors

Regular |
Symlink |

#### Instances

Instances details

NFData SymlinkType Source # |
Instance details Defined in System.Directory.OsPath.Types Methods rnf :: SymlinkType -> () Source #
Generic SymlinkType Source # |

Instance details

Defined in System.Directory.OsPath.Types

Associated Types

type Rep SymlinkType |
Instance details Defined in System.Directory.OsPath.Types type Rep SymlinkType = D1 ('MetaData "SymlinkType" "System.Directory.OsPath.Types" "directory-ospath-streaming-0.2.2-cBThjfpkvuB7SOa12kyJN" 'False) (C1 ('MetaCons "Regular" 'PrefixI 'False) (U1 :: Type -> Type) :+: C1 ('MetaCons "Symlink" 'PrefixI 'False) (U1 :: Type -> Type))

Methods

from :: SymlinkType -> Rep SymlinkType x Source #

to :: Rep SymlinkType x -> SymlinkType Source #

Read SymlinkType Source # |
Instance details Defined in System.Directory.OsPath.Types Methods readsPrec :: Int -> ReadS SymlinkType Source # readList :: ReadS [SymlinkType] Source # readPrec :: ReadPrec SymlinkType Source # readListPrec :: ReadPrec [SymlinkType] Source #
Show SymlinkType Source # |
Instance details Defined in System.Directory.OsPath.Types Methods showsPrec :: Int -> SymlinkType -> ShowS Source # show :: SymlinkType -> String Source # showList :: [SymlinkType] -> ShowS Source #
Eq SymlinkType Source # |
Instance details Defined in System.Directory.OsPath.Types Methods (==) :: SymlinkType -> SymlinkType -> Bool Source # (/=) :: SymlinkType -> SymlinkType -> Bool Source #
Ord SymlinkType Source # |

Instance details

Defined in System.Directory.OsPath.Types

Methods

compare :: SymlinkType -> SymlinkType -> Ordering Source #

(<) :: SymlinkType -> SymlinkType -> Bool Source #

(<=) :: SymlinkType -> SymlinkType -> Bool Source #

(>) :: SymlinkType -> SymlinkType -> Bool Source #

(>=) :: SymlinkType -> SymlinkType -> Bool Source #

max :: SymlinkType -> SymlinkType -> SymlinkType Source #

min :: SymlinkType -> SymlinkType -> SymlinkType Source #

type Rep SymlinkType Source # |
Instance details Defined in System.Directory.OsPath.Types type Rep SymlinkType = D1 ('MetaData "SymlinkType" "System.Directory.OsPath.Types" "directory-ospath-streaming-0.2.2-cBThjfpkvuB7SOa12kyJN" 'False) (C1 ('MetaCons "Regular" 'PrefixI 'False) (U1 :: Type -> Type) :+: C1 ('MetaCons "Symlink" 'PrefixI 'False) (U1 :: Type -> Type))

data FileType Source #

Constructors

File !SymlinkType |
Directory !SymlinkType |
Other !SymlinkType |

#### Instances

Instances details

NFData FileType Source # |
Instance details Defined in System.Directory.OsPath.Types Methods rnf :: FileType -> () Source #
Generic FileType Source # |

Instance details

Defined in System.Directory.OsPath.Types

Associated Types

type Rep FileType |

Instance details

Defined in System.Directory.OsPath.Types

type Rep FileType = D1 ('MetaData "FileType" "System.Directory.OsPath.Types" "directory-ospath-streaming-0.2.2-cBThjfpkvuB7SOa12kyJN" 'False) (C1 ('MetaCons "File" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'SourceUnpack 'SourceStrict 'DecidedStrict) (Rec0 SymlinkType)) :+: (C1 ('MetaCons "Directory" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'SourceUnpack 'SourceStrict 'DecidedStrict) (Rec0 SymlinkType)) :+: C1 ('MetaCons "Other" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'SourceUnpack 'SourceStrict 'DecidedStrict) (Rec0 SymlinkType))))

Methods

from :: FileType -> Rep FileType x Source #

to :: Rep FileType x -> FileType Source #

Read FileType Source # |
Instance details Defined in System.Directory.OsPath.Types Methods readsPrec :: Int -> ReadS FileType Source # readList :: ReadS [FileType] Source # readPrec :: ReadPrec FileType Source # readListPrec :: ReadPrec [FileType] Source #
Show FileType Source # |
Instance details Defined in System.Directory.OsPath.Types Methods showsPrec :: Int -> FileType -> ShowS Source # show :: FileType -> String Source # showList :: [FileType] -> ShowS Source #
Eq FileType Source # |
Instance details Defined in System.Directory.OsPath.Types Methods (==) :: FileType -> FileType -> Bool Source # (/=) :: FileType -> FileType -> Bool Source #
Ord FileType Source # |
Instance details Defined in System.Directory.OsPath.Types Methods compare :: FileType -> FileType -> Ordering Source # (<) :: FileType -> FileType -> Bool Source # (<=) :: FileType -> FileType -> Bool Source # (>) :: FileType -> FileType -> Bool Source # (>=) :: FileType -> FileType -> Bool Source # max :: FileType -> FileType -> FileType Source # min :: FileType -> FileType -> FileType Source #
type Rep FileType Source # |

Instance details

Defined in System.Directory.OsPath.Types

type Rep FileType = D1 ('MetaData "FileType" "System.Directory.OsPath.Types" "directory-ospath-streaming-0.2.2-cBThjfpkvuB7SOa12kyJN" 'False) (C1 ('MetaCons "File" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'SourceUnpack 'SourceStrict 'DecidedStrict) (Rec0 SymlinkType)) :+: (C1 ('MetaCons "Directory" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'SourceUnpack 'SourceStrict 'DecidedStrict) (Rec0 SymlinkType)) :+: C1 ('MetaCons "Other" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'SourceUnpack 'SourceStrict 'DecidedStrict) (Rec0 SymlinkType))))

newtype Basename a Source #

Basename part of filename, without directory separators.

Constructors

Basename |

Fields

- unBasename :: a

#### Instances

Instances details

Functor Basename Source # |
Instance details Defined in System.Directory.OsPath.Types Methods fmap :: (a -> b) -> Basename a -> Basename b Source # (<$) :: a -> Basename b -> Basename a Source #
Foldable Basename Source # |

Instance details

Defined in System.Directory.OsPath.Types

Methods

fold :: Monoid m => Basename m -> m Source #

foldMap :: Monoid m => (a -> m) -> Basename a -> m Source #

foldMap' :: Monoid m => (a -> m) -> Basename a -> m Source #

foldr :: (a -> b -> b) -> b -> Basename a -> b Source #

foldr' :: (a -> b -> b) -> b -> Basename a -> b Source #

foldl :: (b -> a -> b) -> b -> Basename a -> b Source #

foldl' :: (b -> a -> b) -> b -> Basename a -> b Source #

foldr1 :: (a -> a -> a) -> Basename a -> a Source #

foldl1 :: (a -> a -> a) -> Basename a -> a Source #

toList :: Basename a -> [a] Source #

null :: Basename a -> Bool Source #

length :: Basename a -> Int Source #

elem :: Eq a => a -> Basename a -> Bool Source #

maximum :: Ord a => Basename a -> a Source #

minimum :: Ord a => Basename a -> a Source #

sum :: Num a => Basename a -> a Source #

product :: Num a => Basename a -> a Source #

Traversable Basename Source # |
Instance details Defined in System.Directory.OsPath.Types Methods traverse :: Applicative f => (a -> f b) -> Basename a -> f (Basename b) Source # sequenceA :: Applicative f => Basename (f a) -> f (Basename a) Source # mapM :: Monad m => (a -> m b) -> Basename a -> m (Basename b) Source # sequence :: Monad m => Basename (m a) -> m (Basename a) Source #
Generic1 Basename Source # |

Instance details

Defined in System.Directory.OsPath.Types

Associated Types

type Rep1 Basename |
Instance details Defined in System.Directory.OsPath.Types type Rep1 Basename = D1 ('MetaData "Basename" "System.Directory.OsPath.Types" "directory-ospath-streaming-0.2.2-cBThjfpkvuB7SOa12kyJN" 'True) (C1 ('MetaCons "Basename" 'PrefixI 'True) (S1 ('MetaSel ('Just "unBasename") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) Par1))

Methods

from1 :: Basename a -> Rep1 Basename a Source #

to1 :: Rep1 Basename a -> Basename a Source #

NFData a => NFData (Basename a) Source # |
Instance details Defined in System.Directory.OsPath.Types Methods rnf :: Basename a -> () Source #
Generic (Basename a) Source # |

Instance details

Defined in System.Directory.OsPath.Types

Associated Types

type Rep (Basename a) |
Instance details Defined in System.Directory.OsPath.Types type Rep (Basename a) = D1 ('MetaData "Basename" "System.Directory.OsPath.Types" "directory-ospath-streaming-0.2.2-cBThjfpkvuB7SOa12kyJN" 'True) (C1 ('MetaCons "Basename" 'PrefixI 'True) (S1 ('MetaSel ('Just "unBasename") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 a)))

Methods

from :: Basename a -> Rep (Basename a) x Source #

to :: Rep (Basename a) x -> Basename a Source #

Show a => Show (Basename a) Source # |
Instance details Defined in System.Directory.OsPath.Types Methods showsPrec :: Int -> Basename a -> ShowS Source # show :: Basename a -> String Source # showList :: [Basename a] -> ShowS Source #
Eq a => Eq (Basename a) Source # |
Instance details Defined in System.Directory.OsPath.Types Methods (==) :: Basename a -> Basename a -> Bool Source # (/=) :: Basename a -> Basename a -> Bool Source #
Ord a => Ord (Basename a) Source # |

Instance details

Defined in System.Directory.OsPath.Types

Methods

compare :: Basename a -> Basename a -> Ordering Source #

(<) :: Basename a -> Basename a -> Bool Source #

(<=) :: Basename a -> Basename a -> Bool Source #

(>) :: Basename a -> Basename a -> Bool Source #

(>=) :: Basename a -> Basename a -> Bool Source #

max :: Basename a -> Basename a -> Basename a Source #

min :: Basename a -> Basename a -> Basename a Source #

type Rep1 Basename Source # |
Instance details Defined in System.Directory.OsPath.Types type Rep1 Basename = D1 ('MetaData "Basename" "System.Directory.OsPath.Types" "directory-ospath-streaming-0.2.2-cBThjfpkvuB7SOa12kyJN" 'True) (C1 ('MetaCons "Basename" 'PrefixI 'True) (S1 ('MetaSel ('Just "unBasename") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) Par1))
type Rep (Basename a) Source # |
Instance details Defined in System.Directory.OsPath.Types type Rep (Basename a) = D1 ('MetaData "Basename" "System.Directory.OsPath.Types" "directory-ospath-streaming-0.2.2-cBThjfpkvuB7SOa12kyJN" 'True) (C1 ('MetaCons "Basename" 'PrefixI 'True) (S1 ('MetaSel ('Just "unBasename") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 a)))

newtype Relative a Source #

Filename relative to some other path.

Constructors

Relative |

Fields

- unRelative :: a

#### Instances

Instances details

Functor Relative Source # |
Instance details Defined in System.Directory.OsPath.Types Methods fmap :: (a -> b) -> Relative a -> Relative b Source # (<$) :: a -> Relative b -> Relative a Source #
Foldable Relative Source # |

Instance details

Defined in System.Directory.OsPath.Types

Methods

fold :: Monoid m => Relative m -> m Source #

foldMap :: Monoid m => (a -> m) -> Relative a -> m Source #

foldMap' :: Monoid m => (a -> m) -> Relative a -> m Source #

foldr :: (a -> b -> b) -> b -> Relative a -> b Source #

foldr' :: (a -> b -> b) -> b -> Relative a -> b Source #

foldl :: (b -> a -> b) -> b -> Relative a -> b Source #

foldl' :: (b -> a -> b) -> b -> Relative a -> b Source #

foldr1 :: (a -> a -> a) -> Relative a -> a Source #

foldl1 :: (a -> a -> a) -> Relative a -> a Source #

toList :: Relative a -> [a] Source #

null :: Relative a -> Bool Source #

length :: Relative a -> Int Source #

elem :: Eq a => a -> Relative a -> Bool Source #

maximum :: Ord a => Relative a -> a Source #

minimum :: Ord a => Relative a -> a Source #

sum :: Num a => Relative a -> a Source #

product :: Num a => Relative a -> a Source #

Traversable Relative Source # |
Instance details Defined in System.Directory.OsPath.Types Methods traverse :: Applicative f => (a -> f b) -> Relative a -> f (Relative b) Source # sequenceA :: Applicative f => Relative (f a) -> f (Relative a) Source # mapM :: Monad m => (a -> m b) -> Relative a -> m (Relative b) Source # sequence :: Monad m => Relative (m a) -> m (Relative a) Source #
Generic1 Relative Source # |

Instance details

Defined in System.Directory.OsPath.Types

Associated Types

type Rep1 Relative |
Instance details Defined in System.Directory.OsPath.Types type Rep1 Relative = D1 ('MetaData "Relative" "System.Directory.OsPath.Types" "directory-ospath-streaming-0.2.2-cBThjfpkvuB7SOa12kyJN" 'True) (C1 ('MetaCons "Relative" 'PrefixI 'True) (S1 ('MetaSel ('Just "unRelative") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) Par1))

Methods

from1 :: Relative a -> Rep1 Relative a Source #

to1 :: Rep1 Relative a -> Relative a Source #

NFData a => NFData (Relative a) Source # |
Instance details Defined in System.Directory.OsPath.Types Methods rnf :: Relative a -> () Source #
Generic (Relative a) Source # |

Instance details

Defined in System.Directory.OsPath.Types

Associated Types

type Rep (Relative a) |
Instance details Defined in System.Directory.OsPath.Types type Rep (Relative a) = D1 ('MetaData "Relative" "System.Directory.OsPath.Types" "directory-ospath-streaming-0.2.2-cBThjfpkvuB7SOa12kyJN" 'True) (C1 ('MetaCons "Relative" 'PrefixI 'True) (S1 ('MetaSel ('Just "unRelative") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 a)))

Methods

from :: Relative a -> Rep (Relative a) x Source #

to :: Rep (Relative a) x -> Relative a Source #

Show a => Show (Relative a) Source # |
Instance details Defined in System.Directory.OsPath.Types Methods showsPrec :: Int -> Relative a -> ShowS Source # show :: Relative a -> String Source # showList :: [Relative a] -> ShowS Source #
Eq a => Eq (Relative a) Source # |
Instance details Defined in System.Directory.OsPath.Types Methods (==) :: Relative a -> Relative a -> Bool Source # (/=) :: Relative a -> Relative a -> Bool Source #
Ord a => Ord (Relative a) Source # |

Instance details

Defined in System.Directory.OsPath.Types

Methods

compare :: Relative a -> Relative a -> Ordering Source #

(<) :: Relative a -> Relative a -> Bool Source #

(<=) :: Relative a -> Relative a -> Bool Source #

(>) :: Relative a -> Relative a -> Bool Source #

(>=) :: Relative a -> Relative a -> Bool Source #

max :: Relative a -> Relative a -> Relative a Source #

min :: Relative a -> Relative a -> Relative a Source #

type Rep1 Relative Source # |
Instance details Defined in System.Directory.OsPath.Types type Rep1 Relative = D1 ('MetaData "Relative" "System.Directory.OsPath.Types" "directory-ospath-streaming-0.2.2-cBThjfpkvuB7SOa12kyJN" 'True) (C1 ('MetaCons "Relative" 'PrefixI 'True) (S1 ('MetaSel ('Just "unRelative") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) Par1))
type Rep (Relative a) Source # |
Instance details Defined in System.Directory.OsPath.Types type Rep (Relative a) = D1 ('MetaData "Relative" "System.Directory.OsPath.Types" "directory-ospath-streaming-0.2.2-cBThjfpkvuB7SOa12kyJN" 'True) (C1 ('MetaCons "Relative" 'PrefixI 'True) (S1 ('MetaSel ('Just "unRelative") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 a)))